// PD2_Checkout.cpp : implementation file
//

#include "stdafx.h"
#include "USBtest.h"
#include "PD2_Checkout.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPD2_Checkout dialog


CPD2_Checkout::CPD2_Checkout(CWnd* pParent )
	: CDialog(CPD2_Checkout::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPD2_Checkout)
	m_bDAC_Selected = FALSE;
	m_bExt_Input_Selected = FALSE;
	m_bPhase_Det1_Selected = FALSE;
	m_bPhase_Det2_Selected = FALSE;
	m_DAC1_Step_Direction = -1;
	m_DAC_Step_Size = 0;
	m_DAC_Setting = 0;
	m_FPGA_DAC_Setting = 0;
	m_FPGA_DAC_Step_Size = 0;
	m_FPGA_DAC_Direction = -1;
	m_MULT_DAC_Setting = 0;
	m_MULT_DAC_Step_Size = 0;
	m_MULT_DAC_Direction = -1;
	m_ADC1_Reading = 0;
	m_ADC2_Reading = 0;
	m_fltADC1_Volts_In = 0.0f;
	m_fltADC2_Volts_In = 0.0f;
	m_szFull_Filename = _T("");
	m_nDO1 = FALSE;
	m_nDO2 = FALSE;
	m_nDO3 = FALSE;
	m_nDO4 = FALSE;
	m_nHOLD1 = FALSE;
	m_nHOLD2 = FALSE;
	m_Offset_Direction = -1;
	m_Offset_Setting = 0;
	m_Offset_Step = 0;
	m_Set_PD_Choice = -1;
	//}}AFX_DATA_INIT
	
	Initialize_Dialog();
	
}


void CPD2_Checkout::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPD2_Checkout)
	DDX_Control(pDX, IDC_DI_LIST, m_Bit_List);
	DDX_Control(pDX, IDC_LIST_ADC_DATA, m_ADC_Data_List);
	DDX_Check(pDX, IDC_SEL_DAC, m_bDAC_Selected);
	DDX_Check(pDX, IDC_SEL_EXT_INPUT, m_bExt_Input_Selected);
	DDX_Check(pDX, IDC_SEL_MADC1, m_bPhase_Det1_Selected);
	DDX_Check(pDX, IDC_SEL_MADC2, m_bPhase_Det2_Selected);
	DDX_Radio(pDX, IDC_STEP_UP, m_DAC1_Step_Direction);
	DDX_Text(pDX, IDC_DAC_STEP, m_DAC_Step_Size);
	DDV_MinMaxUInt(pDX, m_DAC_Step_Size, 1, 16384);
	DDX_Text(pDX, IDC_DAC_1_SETTING, m_DAC_Setting);
	DDV_MinMaxUInt(pDX, m_DAC_Setting, 0, 65535);
	DDX_Text(pDX, IDC_DAC_1_SETTING2, m_FPGA_DAC_Setting);
	DDV_MinMaxUInt(pDX, m_FPGA_DAC_Setting, 0, 16383);
	DDX_Text(pDX, IDC_DAC_STEP2, m_FPGA_DAC_Step_Size);
	DDV_MinMaxUInt(pDX, m_FPGA_DAC_Step_Size, 1, 4096);
	DDX_Radio(pDX, IDC_STEP_UP2, m_FPGA_DAC_Direction);
	DDX_Text(pDX, IDC_DAC_1_SETTING3, m_MULT_DAC_Setting);
	DDX_Text(pDX, IDC_DAC_STEP3, m_MULT_DAC_Step_Size);
	DDX_Radio(pDX, IDC_STEP_UP3, m_MULT_DAC_Direction);
	DDX_Text(pDX, IDC_ADC1_Reading, m_ADC1_Reading);
	DDX_Text(pDX, IDC_ADC2_Reading, m_ADC2_Reading);
	DDX_Text(pDX, IDC_ADC1_VOLTS_IN, m_fltADC1_Volts_In);
	DDX_Text(pDX, IDC_ADC2_VOLTS_IN, m_fltADC2_Volts_In);
	DDX_Text(pDX, IDC_DATA_FILENAME, m_szFull_Filename);
	DDX_Check(pDX, IDC_D0_BUTTON1, m_nDO1);
	DDX_Check(pDX, IDC_D0_BUTTON2, m_nDO2);
	DDX_Check(pDX, IDC_D0_BUTTON3, m_nDO3);
	DDX_Check(pDX, IDC_D0_BUTTON4, m_nDO4);
	DDX_Check(pDX, IDC_HOLD_BUTTON1, m_nHOLD1);
	DDX_Check(pDX, IDC_HOLD_BUTTON2, m_nHOLD2);
	DDX_Radio(pDX, IDC_STEP_UP4, m_Offset_Direction);
	DDX_Text(pDX, IDC_OFFSET_SET, m_Offset_Setting);
	DDX_Text(pDX, IDC_OFFSET_STEP, m_Offset_Step);
	DDX_Radio(pDX, IDC_SET_PD1, m_Set_PD_Choice);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPD2_Checkout, CDialog)
	//{{AFX_MSG_MAP(CPD2_Checkout)
	ON_BN_CLICKED(IDC_WR_DAC_1, OnWriteDac1)
	ON_BN_CLICKED(IDC_SEL_DAC, OnSelDac)
	ON_BN_CLICKED(IDC_SEL_EXT_INPUT, OnSelExtInput)
	ON_BN_CLICKED(IDC_SEL_MADC1, OnSelMadc1)
	ON_BN_CLICKED(IDC_SEL_MADC2, OnSelMadc2)
	ON_BN_CLICKED(IDC_WR_FPGA_DAC, OnWrFpgaDac)
	ON_BN_CLICKED(IDC_WR_MULT_DACS, OnWrMultDacs)
	ON_BN_CLICKED(IDC_WR_ADC_TO_FILE, OnWrAdcToFile)
	ON_BN_CLICKED(IDC_START_NEW_FILE, OnStartNewFile)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESET_FILE_SEQ, OnResetFileSeq)
	ON_BN_CLICKED(IDC_D0_BUTTON1, OnD0Button1)
	ON_BN_CLICKED(IDC_D0_BUTTON2, OnD0Button2)
	ON_BN_CLICKED(IDC_D0_BUTTON3, OnD0Button3)
	ON_BN_CLICKED(IDC_D0_BUTTON4, OnD0Button4)
	ON_BN_CLICKED(IDC_HOLD_BUTTON1, OnHoldButton1)
	ON_BN_CLICKED(IDC_HOLD_BUTTON2, OnHoldButton2)
	ON_BN_CLICKED(IDC_WR_OFFSET, OnWrOffset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPD2_Checkout message handlers

void CPD2_Checkout::Initialize_Dialog()
{

	
}




BOOL CPD2_Checkout::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	unsigned int	val;
	int				status;


	//==============================================================================
	//  Cntrl_Reg = Parameter 7 (15 downto 0)
	//  
	// |   0    |    1    |     2     |     3     |    4   |    5   |   6  |   7  |
	// ----------------------------------------------------------------------------
	// |Sel_DAC | Sel_Ext | Sel_MADC2 | Sel_MADC1 | HOLD_1 | HOLD_2 | DO_1 | DO_2 | 
	//                                                              | LED1 | LED2 |


	// |   8   |   9   |    10    |   11  |   12    |   13    |   14    |   15    | 
	// ----------------------------------------------------------------------------
	// | DO_3  | DO_4  | ENA_TST  |   x   |          DIAG_SEL[0..3]               |
	// | LED3  | LED4  |


	//===== Set Cntrl_Reg Bit 10 to enable control of digital IO =========
	val = 0x1000;     // <<<<<< here is the new bit to select test mode (was 0x0400)
	pUSB->write_param(7, &val);

	m_DAC_Setting = 0x8000; //32768
	m_DAC_Step_Size = 0x0100; //256
	pUSB->write_param(10, &m_DAC_Setting);

	m_FPGA_DAC_Setting = 0x2000; //8192
	m_FPGA_DAC_Step_Size = 0x0100; //256
	pUSB->write_param(9, &m_FPGA_DAC_Setting);

	m_MULT_DAC_Setting = 0x0800; //2048
	m_MULT_DAC_Step_Size = 0x0010; //16
	pUSB->write_param(0, &m_MULT_DAC_Setting);
	pUSB->write_param(2, &m_MULT_DAC_Setting);

	m_Offset_Setting = 0x0800; //2048
	m_Offset_Step    = 0x0010; //16
	pUSB->write_param(1, &m_Offset_Setting);
	pUSB->write_param(3, &m_Offset_Setting);

	m_DAC1_Step_Direction = 0;
	m_FPGA_DAC_Direction = 0;
	m_MULT_DAC_Direction = 0;
	m_Offset_Direction = 0;
	m_Set_PD_Choice = 0;


	//-------------- ADC Test Result File Index ------------------------------
	// This index is used to generate a series of unique file names for the
	// PD2_Checkout Dialog Box.

	basefilename = "ADC_Data_File";

	m_nFileIndex = AfxGetApp()->GetProfileInt("MyUSBTestAp", "FileIndex", 0);
	char	szindex[5];
	sprintf(szindex,"%d",++m_nFileIndex);
	m_szFull_Filename = basefilename + szindex + ".csv";
	fp = fopen(m_szFull_Filename, "w");
	if (fp == NULL) {AfxMessageBox("could not open file to save ADC data"); return TRUE;;}

	m_fltADC1_Volts_In = (float) 0.001;
	m_fltADC2_Volts_In = (float) 0.002;

	m_ADC_Data_List.ResetContent();

	UpdateData(FALSE);


	//--------- Setup Labels (strings) for displaying Digital input states ------
/*	strcpy( szDIO[0],	"DIN_1"); 	strcpy( szDIO[8],	"BEAM1");
	strcpy( szDIO[1],	"DIN_2"); 	strcpy( szDIO[9],	"BEAM2");
	strcpy( szDIO[2],	"DIN_3"); 	strcpy( szDIO[10],	"HOLD1");
	strcpy( szDIO[3],	"DIN_4"); 	strcpy( szDIO[11],	"HOLD2");
	strcpy( szDIO[4],	"TRG_1"); 	strcpy( szDIO[12],	"LED_1");
	strcpy( szDIO[5],	"TRG_2"); 	strcpy( szDIO[13],	"LED_2");
	strcpy( szDIO[6],	"TRG_3"); 	strcpy( szDIO[14],	"LED_3");
	strcpy( szDIO[7],	"TRG_4"); 	strcpy( szDIO[15],	"LED_4");
*/
	szDIO[0]=	"DIN_1"; 	szDIO[8] =	"BEAM1";
	szDIO[1]=	"DIN_2"; 	szDIO[9] =	"BEAM2";
	szDIO[2]=	"DIN_3"; 	szDIO[10]=	"HOLD1";
	szDIO[3]=	"DIN_4"; 	szDIO[11]=	"HOLD2";
	szDIO[4]=	"TRG_1"; 	szDIO[12]=	"LED_1";
	szDIO[5]=	"TRG_2"; 	szDIO[13]=	"LED_2";
	szDIO[6]=	"TRG_3"; 	szDIO[14]=	"LED_3";
	szDIO[7]=	"TRG_4"; 	szDIO[15]=	"LED_4";



	//------------- Start an Update Timer ---------------------------------------
	//
	pADC1   = GetDlgItem(IDC_ADC1_Reading); // cannot use UpdateData to update these.
	pADC2   = GetDlgItem(IDC_ADC2_Reading); // cannot use UpdateData to update these.
	pDIGITS = GetDlgItem(IDC_DIGITS);
	m_nUpdateTimer = SetTimer(1, 700, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//=====================================================================================
// Update Timer Task

void CPD2_Checkout::OnTimer(UINT nIDEvent) 
{
	int status;
	char val[20];
	unsigned int  digits;

	status = pUSB->read_chan(0, &m_ADC1_Reading); //read current value of ADC1
	if (status < 0) {AfxMessageBox("Parameter Read Failed"); return;}

	sprintf(val,"%d",m_ADC1_Reading);
	pADC1->SetWindowText(val);

	status = pUSB->read_chan(1, &m_ADC2_Reading); //read current value of ADC1
	if (status < 0) {AfxMessageBox("Parameter Read Failed"); return;}

	sprintf(val,"%d",m_ADC2_Reading);
	pADC2->SetWindowText(val);

	status = pUSB->read_chan(3, &digits); //read current value of ADC1
	if (status < 0) {AfxMessageBox("Parameter Read Failed"); return;}

	sprintf(val,"0x%4X",digits);
	pDIGITS->SetWindowText(val);

//	Update_Bit_List(digits);
	Update_Bit_List(digits);

	//MessageBeep(0x00000030L); //un-comment to see if routine is being triggered
	
	CDialog::OnTimer(nIDEvent);
}

void CPD2_Checkout::Update_Bit_List(unsigned int val)
{
	int i;
	unsigned int   word = 1;

	char*	HI = "  1 : ";
	char*	LO = "  0 : ";
	char	LINE[12];

	m_Bit_List.ResetContent();
	m_Bit_List.AddString(" ");

	for(i=0;i<16;i++)
	{
		if((val & (word << i)) > 0)  strcpy(LINE,HI);
		else						 strcpy(LINE,LO);

		strcat(LINE,szDIO[i]);
		m_Bit_List.AddString(LINE);

	}
}

//============================================================
// There is are 4 SPST switches that connect/disconnect the 4
// possible inputs of the Summing Amplifier.  These routines
// respond to the selections in the dialog box.

// The switches are controlled by the bits of the Control Register
// "CNT_REG[3..0]", register 7 with the following assignment
// 
// DAC Selected:		bit 0
// Ext Input Selected:	bit 1
// MADC 2 Selected:		bit 2  (Phase Detector 2 output)
// MADC 1 Selected:		bit 3  (Phase Detector 1 output)

void CPD2_Checkout::OnSelDac() 
{
	UpdateData(TRUE);
	SetRegisterBit((long)7, (int)0, m_bDAC_Selected);
}

void CPD2_Checkout::OnSelExtInput() 
{
	UpdateData(TRUE);
	SetRegisterBit((long)7, (int)1, m_bExt_Input_Selected);			
}

void CPD2_Checkout::OnSelMadc1() 
{
	UpdateData(TRUE);
	SetRegisterBit((long)7, (int)3, m_bPhase_Det1_Selected);			
}

void CPD2_Checkout::OnSelMadc2() 
{
	UpdateData(TRUE);
	SetRegisterBit((long)7, (int)2, m_bPhase_Det2_Selected);			
}

//=========================================================================
void CPD2_Checkout::SetRegisterBit(int index, int bit, int setting)
{
	unsigned int	val;
	int				status;
	unsigned int   word = 1;
	
	status = pUSB->read_param(index, &val);
	if (status < 0) {AfxMessageBox("Parameter Read Failed"); return;}
	
//char msg[80];
//sprintf(msg,"bit=%d, word=%d, setting=%d, val=%d",bit,word,setting,val);
//AfxMessageBox(msg);

	// set up our word used to change the bits
	word = word << bit;

	if (setting == 1)	val = val | word;
	else				val = val & ~word;



	pUSB->write_param(index, &val);

//		status = pUSB->read_param(index, &val);
//		sprintf(msg,"bit=%d, word=%d, setting=%d, val=%d",bit,word,setting,val);
//		AfxMessageBox(msg);


}

void CPD2_Checkout::OnWriteDac1() 
{
	UINT new_setting;

	UpdateData(TRUE);

	if(m_DAC1_Step_Direction == 0) //up
	{
		new_setting = m_DAC_Setting + m_DAC_Step_Size; 
		if(new_setting > 0xFFFF) m_DAC_Setting = 0xFFFF;
		else					 m_DAC_Setting = new_setting;
	}
	else if(m_DAC1_Step_Direction == 1) //dn
	{
		new_setting = m_DAC_Setting - m_DAC_Step_Size; 
		if(new_setting > m_DAC_Setting) m_DAC_Setting = 0;
		else							m_DAC_Setting = new_setting;

	}

	// else set DAC to current setting

	pUSB->write_param(10, &m_DAC_Setting);

	UpdateData(FALSE);

}


void CPD2_Checkout::OnWrFpgaDac() 
{
	UINT new_setting;

	UpdateData(TRUE);

	if(m_FPGA_DAC_Direction == 0) 
	{
		new_setting = m_FPGA_DAC_Setting + m_FPGA_DAC_Step_Size; 
		if(new_setting > 0x3FFF) m_FPGA_DAC_Setting = 0x3FFF;
		else					 m_FPGA_DAC_Setting = new_setting;
	}
	else if(m_FPGA_DAC_Direction == 1) 
	{
		new_setting = m_FPGA_DAC_Setting - m_FPGA_DAC_Step_Size; 
		if(new_setting > m_FPGA_DAC_Setting) m_FPGA_DAC_Setting = 0;
		else								 m_FPGA_DAC_Setting = new_setting;

	}

	// else set DAC to current setting

	pUSB->write_param(9, &m_FPGA_DAC_Setting);

	UpdateData(FALSE);
	
}

void CPD2_Checkout::OnWrMultDacs() 
{
	UINT new_setting;

	UpdateData(TRUE);

	if(m_MULT_DAC_Direction == 0) 
	{
		new_setting = m_MULT_DAC_Setting + m_MULT_DAC_Step_Size; 
		if(new_setting > 0x0FFF) m_MULT_DAC_Setting = 0x0FFF;
		else					 m_MULT_DAC_Setting = new_setting;
	}
	else if(m_MULT_DAC_Direction == 1) 
	{
		new_setting = m_MULT_DAC_Setting - m_MULT_DAC_Step_Size; 
		if(new_setting > m_MULT_DAC_Setting) m_MULT_DAC_Setting = 0;
		else								 m_MULT_DAC_Setting = new_setting;

	}

	// else set DAC to current setting

	pUSB->write_param(0, &m_MULT_DAC_Setting);
	pUSB->write_param(2, &m_MULT_DAC_Setting);

	UpdateData(FALSE);	
}

void CPD2_Checkout::OnWrOffset() 
{
	UINT new_setting;

	UpdateData(TRUE);

	if(m_Offset_Direction == 0) 
	{
		new_setting = m_Offset_Setting + m_Offset_Step; 
		if(new_setting > 0x0FFF) m_Offset_Setting = 0x0FFF;
		else					 m_Offset_Setting = new_setting;
	}
	else if(m_Offset_Direction == 1) 
	{
		new_setting = m_Offset_Setting - m_Offset_Step; 
		if(new_setting > m_Offset_Setting)	m_Offset_Setting = 0;
		else								m_Offset_Setting = new_setting;

	}

	// else set DAC to current setting

	if (m_Set_PD_Choice == 0) pUSB->write_param(1, &m_Offset_Setting);
	else                      pUSB->write_param(3, &m_Offset_Setting);

	UpdateData(FALSE);		
}


void CPD2_Checkout::OnWrAdcToFile() 
{
	char msg[80];
	UpdateData(TRUE);

	fprintf(fp,"%d, %f, %d, %f \n",m_ADC1_Reading, 
		m_fltADC1_Volts_In, m_ADC2_Reading, m_fltADC2_Volts_In);

	sprintf(msg,"%d, %f, %d, %f \n",m_ADC1_Reading, 
		m_fltADC1_Volts_In, m_ADC2_Reading, m_fltADC2_Volts_In);

	m_ADC_Data_List.AddString(msg);	
}

void CPD2_Checkout::OnStartNewFile() 
{
	char	szindex[5];

	sprintf(szindex,"%d",++m_nFileIndex);
	m_szFull_Filename = basefilename + szindex + ".csv";
	AfxGetApp()->WriteProfileInt("MyUSBTestAp", "FileIndex", m_nFileIndex);	

	if(fp != NULL) fclose(fp);
	
	fp = fopen(m_szFull_Filename, "w");
	if (fp == NULL) {AfxMessageBox("could not open file to save ADC data"); return;}

	m_ADC_Data_List.ResetContent();

	UpdateData(FALSE);	

}

void CPD2_Checkout::OnOK() 
{
	if(fp != NULL) fclose(fp);

	SetRegisterBit(7, 10, 1);
	AfxMessageBox("Paramters were restored from the EEPROM");
	SetRegisterBit(7, 10, 0);

	CDialog::OnOK();
}

void CPD2_Checkout::OnResetFileSeq() 
{
	UpdateData(TRUE);
	m_nFileIndex = 0;
	OnStartNewFile();
	
}


	//==============================================================================
	//  Cntrl_Reg = Parameter 7 (15 downto 0)
	//  
	// |   0    |    1    |     2     |     3     |    4   |    5   |   6  |   7  |
	// ----------------------------------------------------------------------------
	// |Sel_DAC | Sel_Ext | Sel_MADC2 | Sel_MADC1 | HOLD_1 | HOLD_2 | DO_1 | DO_2 | 
	//                                                              | LED1 | LED2 |


	// |   8   |   9   |    10    |   11  |   12    |   13    |   14    |   15    | 
	// ----------------------------------------------------------------------------
	// | DO_3  | DO_4  | RESET ALL|   x   | ENA_TST | DIAG_SEL[0..3]             |
	// | LED3  | LED4  |

void CPD2_Checkout::OnD0Button1() 
{
	UpdateData(TRUE);
	SetRegisterBit(7, 6, m_nDO1);
	
}

void CPD2_Checkout::OnD0Button2() 
{
	UpdateData(TRUE);
	SetRegisterBit(7, 7, m_nDO2);
	
}

void CPD2_Checkout::OnD0Button3() 
{
	UpdateData(TRUE);
	SetRegisterBit(7, 8, m_nDO3);
	
}

void CPD2_Checkout::OnD0Button4() 
{
	UpdateData(TRUE);
	SetRegisterBit(7, 9, m_nDO4);
	
}

void CPD2_Checkout::OnHoldButton1() 
{
	UpdateData(TRUE);
	SetRegisterBit(7, 4, m_nHOLD1);
	
}

void CPD2_Checkout::OnHoldButton2() 
{
	UpdateData(TRUE);
	SetRegisterBit(7, 5, m_nHOLD2);
	
}

