// UM245R_Interface.cpp : implementation file
//

#include "stdafx.h"
#include "USBtest.h"  // I do not think this is necessary.  Remove after testing !!!!!
#include "UM245R_Interface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UM245R_Interface dialog


UM245R_Interface::UM245R_Interface(CWnd* pParent /*=NULL*/)
	: CDialog(UM245R_Interface::IDD, pParent)
{
	//{{AFX_DATA_INIT(UM245R_Interface)
	m_PortStatus = _T("");
	m_SerDesc = -1;
	m_NameNmbr = _T("");
	//}}AFX_DATA_INIT

		LoadDLL();
		board_present = 0;
		bus_busy = 0;

	//------------- Controls to Select Method for Opening USB Device ---------
	// This code and dialog box provides some controls for searching for
	// available USB devices to attach to.  "m_SerDesc" is the selected
	// choice of three radio button options for searching for USB devices.
	
	// Read the last settings from the registry

	   m_SerDesc = AfxGetApp()->GetProfileInt("MyUSBTestAp", "SerDesc", 0);//default to Description

	if(m_SerDesc==0)
		m_NameNmbr = AfxGetApp()->GetProfileString("MyUSBTestAp", "DescString", "Enter device Description or Serial Number here.");
	if(m_SerDesc==1)
		m_NameNmbr = AfxGetApp()->GetProfileString("MyUSBTestAp", "SerialString", "Enter device Description or Serial Number here.");
	if(m_SerDesc==2)
		m_NameNmbr = AfxGetApp()->GetProfileString("MyUSBTestAp", "DevNmbr", "Enter device Description or Serial Number here.");

	//-----------------------------------------------------------------------
	
}

UM245R_Interface::~UM245R_Interface()
{
	Close();
	FreeLibrary(m_hmodule);
}


void UM245R_Interface::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(UM245R_Interface)
	DDX_Control(pDX, IDC_LIST1, m_Received);
	DDX_Text(pDX, IDC_EDIT_PORT_STATUS, m_PortStatus);
	DDX_Radio(pDX, IDC_RADIO_NAME_NUM, m_SerDesc);
	DDX_Text(pDX, IDC_EDIT_NAME_NUMBER, m_NameNmbr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(UM245R_Interface, CDialog)
	//{{AFX_MSG_MAP(UM245R_Interface)
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, OnButtonSearch)
	ON_EN_CHANGE(IDC_EDIT_NAME_NUMBER, OnChangeEditNameNumber)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_BN_CLICKED(IDC_OPEN_USB, OnOpenUsb)
	ON_BN_CLICKED(IDC_RADIO_DEVNO, OnRadioDevno)
	ON_BN_CLICKED(IDC_RADIO_SERNUM, OnRadioSernum)
	ON_BN_CLICKED(IDC_RADIO_NAME_NUM, OnRadioNameNum)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UM245R_Interface Dialog message handlers

void UM245R_Interface::OnButtonSearch() 
{
	//search for Descriptions or Serial Numbers depending on the current mode
	FT_STATUS ftStatus;
	DWORD numDevs;

	Close();//must be closed to perform the ListDevices() function

	UpdateData(TRUE);
	m_PortStatus = _T("DLP-USB Closed.");
	m_NameNmbr = _T("");
	m_Received.ResetContent();
	UpdateData(FALSE);
	UpdateWindow();

	ftStatus = ListDevices(&numDevs, NULL, FT_LIST_NUMBER_ONLY);
	if(ftStatus == FT_OK) 
	{
		// FT_ListDevices OK, show number of devices connected in list box
		CString str;
		str.Format("%d device(s) attached:", (int)numDevs);
		m_Received.AddString(str);		


		//if current mode is open "by device #" then list device numbers
		if((m_SerDesc==2) && (numDevs>0))
		{
			for(DWORD d=0; d<numDevs; d++)
			{
				str.Format("%d", d);
				m_Received.AddString(str);		
			}

		}

		//if current mode is open "by description" then list descriptions of all connected devices
		if((m_SerDesc==0) && (numDevs>0))
		{
			ftStatus = ListDevices(&numDevs, NULL, FT_LIST_NUMBER_ONLY);
			if(ftStatus == FT_OK) 
			{
				char *BufPtrs[64]; // pointer to array of 64 pointers
				for(DWORD d=0; d<numDevs; d++)
					BufPtrs[d] = new char[64];
				BufPtrs[d] = NULL;

				ftStatus = ListDevices(BufPtrs, &numDevs, FT_LIST_ALL|FT_OPEN_BY_DESCRIPTION);
				if (FT_SUCCESS(ftStatus)) 
				{
					for(DWORD u=0; u<numDevs; u++)
					{
						str.Format("%s", BufPtrs[u]);
						m_Received.AddString(str);		
					}
				}
				else 
				{
					str.Format("ListDevices failed");
					m_Received.AddString(str);		
				}	

				//free ram to avoid memory leaks
				for(d=0; d<numDevs; d++)
				{
					delete BufPtrs[d];  
				}
			}		
		}

		//if current mode is open "by serial number" the list descriptions 
		//of all connected devices
		if((m_SerDesc==1) && (numDevs>0))
		{
			//AfxMessageBox("by serial"); 
			ftStatus = ListDevices(&numDevs, NULL, FT_LIST_NUMBER_ONLY);
			if(ftStatus == FT_OK) 
			{
				char *BufPtrs[64]; // pointer to array of 64 pointers
				for(DWORD d=0; d<numDevs; d++)
					BufPtrs[d] = new char[64];
				BufPtrs[d] = NULL;

				ftStatus = ListDevices(BufPtrs, &numDevs, FT_LIST_ALL|FT_OPEN_BY_SERIAL_NUMBER);
				if (FT_SUCCESS(ftStatus)) 
				{
					for(DWORD u=0; u<numDevs; u++)
					{
						str.Format("%s", BufPtrs[u]);
						m_Received.AddString(str);		
					}
				}
				else 
				{
					str.Format("ListDevices failed");
					m_Received.AddString(str);		
				}	

				//free ram to avoid memory leaks
				for(d=0; d<numDevs; d++)
					delete BufPtrs[d];  
			}
		}

	}
	else 
	{
		// FT_ListDevices failed
		AfxMessageBox("FT_ListDevices failed"); 
	}	
}

void UM245R_Interface::OnChangeEditNameNumber() 
{
	UpdateData(TRUE);

	//write the new setup to the registry
	if(m_SerDesc==0)
		AfxGetApp()->WriteProfileString("MyUSBTestAp", "DescString", m_NameNmbr);
	if(m_SerDesc==1)
		AfxGetApp()->WriteProfileString("MyUSBTestAp", "SerialString", m_NameNmbr);
	if(m_SerDesc==2)
		AfxGetApp()->WriteProfileString("MyUSBTestAp", "DevNmbr", m_NameNmbr);

	if(m_NameNmbr.GetLength() < 1)
		m_SerDesc = 2;
	UpdateData(FALSE);
	UpdateWindow();
}

void UM245R_Interface::OnSelchangeList1() 
{
	UpdateData(TRUE);
	
	int pos = m_Received.GetCurSel();
	m_Received.GetText(pos, m_NameNmbr);

	UpdateData(FALSE);
	UpdateWindow();

	if(m_SerDesc==0)
		AfxGetApp()->WriteProfileString("MyUSBTestAp", "DescString", m_NameNmbr);
	if(m_SerDesc==1)
		AfxGetApp()->WriteProfileString("MyUSBTestAp", "SerialString", m_NameNmbr);
	if(m_SerDesc==2)
		AfxGetApp()->WriteProfileString("MyUSBTestAp", "DevNmbr", m_NameNmbr);	
	
}

//========================================================================================
// OPENBY RADIO BUTTONS

void UM245R_Interface::OnRadioDevno() 
{
	CWinApp* pApp = AfxGetApp();  
	//write the new setup to the registry
	pApp->WriteProfileInt("MyUSBTestAp", "SerDesc", 2);

	UpdateData(TRUE);
	m_NameNmbr = AfxGetApp()->GetProfileString("MyUSBTestAp", "DevNmbr", "Enter device Description or Serial Number here.");
	UpdateData(FALSE);
	UpdateWindow();
	
}

void UM245R_Interface::OnRadioSernum() 
{
	CWinApp* pApp = AfxGetApp();  
	//write the new setup to the registry
	pApp->WriteProfileInt("MyUSBTestAp", "SerDesc", 1);

	UpdateData(TRUE);
	m_NameNmbr = AfxGetApp()->GetProfileString("MyUSBTestAp", "SerialString", "Enter device Description or Serial Number here.");
	UpdateData(FALSE);
	UpdateWindow();	
}

void UM245R_Interface::OnRadioNameNum() 
{
	CWinApp* pApp = AfxGetApp();  
	//write the new setup to the registry
	pApp->WriteProfileInt("MyUSBTestAp", "SerDesc", 0);

	UpdateData(TRUE);
	m_NameNmbr = AfxGetApp()->GetProfileString("MyUSBTestAp", "DescString", "Enter device Description or Serial Number here.");
	UpdateData(FALSE);
	UpdateWindow();	
}


void UM245R_Interface::OnOpenUsb() 
{
	UpdateData(TRUE);
	m_PortStatus = _T("-reset-");
	UpdateData(FALSE);
	UpdateWindow();

	Close();
	Initialize_USB_Interface();	
	UpdateData(FALSE);
	UpdateWindow();

	
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// UM245R Methods

int UM245R_Interface::Initialize_USB_Interface()
{
	int init_status=0;
	//open the device
	FT_STATUS status = OpenBy();

	if(status)
	{
		m_PortStatus = _T("USB not responding");
		board_present = 0;
	}
	else
	{
		init_status = 1;
		ResetDevice();
		SetTimeouts(3000, 3000);//extend timeout while board DLP-USB finishes reset
		Purge(FT_PURGE_RX || FT_PURGE_TX);
		Sleep(150);
		
		m_PortStatus = _T("USB ready.");
		board_present = 1;

	}

	SetTimeouts(300, 300);
	UpdateWindow();
	return init_status;
}

//==========================================================================
FT_STATUS UM245R_Interface::OpenBy()
{
	if(m_NameNmbr.Find("Enter device Description") > -1)
	{
		//highlight the descriptor/serial number to draw attention...
		CEdit *pEdt;
		pEdt = (CEdit *)GetDlgItem(IDC_EDIT_NAME_NUMBER);
		pEdt->SetFocus();
		pEdt->SetSel(0, -1, FALSE);
		AfxMessageBox("You must enter a Device Description or Serial Number.");
		return FT_DEVICE_NOT_OPENED;
	}

	FT_STATUS status;
	ULONG x=0;
	if(m_SerDesc==0)
	{
		status = OpenEx((PVOID)(LPCTSTR)m_NameNmbr, FT_OPEN_BY_DESCRIPTION);
	}

	if(m_SerDesc==1)
	{
		status = OpenEx((PVOID)(LPCTSTR)m_NameNmbr, FT_OPEN_BY_SERIAL_NUMBER);
	}

	if((m_SerDesc==2) || (m_SerDesc==-1))//if open by device OR no method was selected
	{
		if(m_NameNmbr.GetLength() < 1)//nothing entered - open default device 0
		{
			status = Open((PVOID)x);//load default device 0
		}
	   else
	   {
			if(m_NameNmbr.GetLength() > 2)//no Open() method selected...
			{
				AfxMessageBox("Select a method to open or enter a valid device number (0-64).");
				return FT_DEVICE_NOT_OPENED;
			}

			//convert string to decimal number and open(x)
			char str[3];
			strcpy(str, (LPCTSTR)m_NameNmbr);
			x = atoi(str);
			if((x<0) || (x>64))
			{
				AfxMessageBox("Select a method to open or enter a valid device number (0-64).");
				return FT_DEVICE_NOT_OPENED; 
			}
			status = Open((PVOID)x);
	   }
	}

	return status;
}


//****************************************************************************************
void UM245R_Interface::LoadDLL()
{
	m_hmodule = LoadLibrary("Ftd2xx.dll");	
	if(m_hmodule == NULL)
	{
		AfxMessageBox("Error: Can't Load ft8u245.dll");
		return;
	}

	m_pWrite = (PtrToWrite)GetProcAddress(m_hmodule, "FT_Write");
	if (m_pWrite == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Write");
		return;
	}

	m_pRead = (PtrToRead)GetProcAddress(m_hmodule, "FT_Read");
	if (m_pRead == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Read");
		return;
	}

	m_pOpen = (PtrToOpen)GetProcAddress(m_hmodule, "FT_Open");
	if (m_pOpen == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Open");
		return;
	}

	m_pOpenEx = (PtrToOpenEx)GetProcAddress(m_hmodule, "FT_OpenEx");
	if (m_pOpenEx == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_OpenEx");
		return;
	}

	m_pListDevices = (PtrToListDevices)GetProcAddress(m_hmodule, "FT_ListDevices");
	if(m_pListDevices == NULL)
		{
			AfxMessageBox("Error: Can't Find FT_ListDevices");
			return;
		}

	m_pClose = (PtrToClose)GetProcAddress(m_hmodule, "FT_Close");
	if (m_pClose == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Close");
		return;
	}

	m_pResetDevice = (PtrToResetDevice)GetProcAddress(m_hmodule, "FT_ResetDevice");
	if (m_pResetDevice == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_ResetDevice");
		return;
	}

	m_pPurge = (PtrToPurge)GetProcAddress(m_hmodule, "FT_Purge");
	if (m_pPurge == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Purge");
		return;
	}

	m_pSetTimeouts = (PtrToSetTimeouts)GetProcAddress(m_hmodule, "FT_SetTimeouts");
	if (m_pSetTimeouts == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_SetTimeouts");
		return;
	}

	m_pGetQueueStatus = (PtrToGetQueueStatus)GetProcAddress(m_hmodule, "FT_GetQueueStatus");
	if (m_pGetQueueStatus == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_GetQueueStatus");
		return;
	}

}	

//****************************************************************************************
FT_STATUS UM245R_Interface::Read(LPVOID lpvBuffer, DWORD dwBuffSize, LPDWORD lpdwBytesRead)
{
	if (!m_pRead)
	{
		AfxMessageBox("FT_Read is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pRead)(m_ftHandle, lpvBuffer, dwBuffSize, lpdwBytesRead);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::Write(LPVOID lpvBuffer, DWORD dwBuffSize, LPDWORD lpdwBytes)
{
	if (!m_pWrite)
	{
		AfxMessageBox("FT_Write is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pWrite)(m_ftHandle, lpvBuffer, dwBuffSize, lpdwBytes);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::Open(PVOID pvDevice)
{
	if (!m_pOpen)
	{
		AfxMessageBox("FT_Open is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pOpen)(pvDevice, &m_ftHandle );
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::OpenEx(PVOID pArg1, DWORD dwFlags)
{
	if (!m_pOpenEx)
	{
		AfxMessageBox("FT_OpenEx is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pOpenEx)(pArg1, dwFlags, &m_ftHandle);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::ListDevices(PVOID pArg1, PVOID pArg2, DWORD dwFlags)
{
	if (!m_pListDevices)
	{
		AfxMessageBox("FT_ListDevices is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pListDevices)(pArg1, pArg2, dwFlags);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::Close()
{
	if (!m_pClose)
	{
		AfxMessageBox("FT_Close is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pClose)(m_ftHandle);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::ResetDevice()
{
	if (!m_pResetDevice)
	{
		AfxMessageBox("FT_ResetDevice is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pResetDevice)(m_ftHandle);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::Purge(ULONG dwMask)
{
	if (!m_pPurge)
	{
		AfxMessageBox("FT_Purge is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pPurge)(m_ftHandle, dwMask);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::SetTimeouts(ULONG dwReadTimeout, ULONG dwWriteTimeout)
{
	if (!m_pSetTimeouts)
	{
		AfxMessageBox("FT_SetTimeouts is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pSetTimeouts)(m_ftHandle, dwReadTimeout, dwWriteTimeout);
}	

//****************************************************************************************
FT_STATUS UM245R_Interface::GetQueueStatus(LPDWORD lpdwAmountInRxQueue)
{
	if (!m_pGetQueueStatus)
	{
		AfxMessageBox("FT_GetQueueStatus is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pGetQueueStatus)(m_ftHandle, lpdwAmountInRxQueue);
}	



CString UM245R_Interface::Get_USB_Status()
{
	return m_PortStatus;
}

//===========================================================================
CString UM245R_Interface::read_param_str(long index, int ishex)
{
	unsigned int	val;
	int				status;
	char			szval[20];
	CString			szReading;

	if(!board_present)
		return -1;

	bus_busy=1;
	//buttons(OFF); //not used
	status = read_param(index, &val);

	if(ishex == 1) 
	{
		sprintf(szval,"%4.4x", val); // four digits with leading zeros
		szReading.Format(_T("%s"), szval) ; 
		szReading.MakeUpper();
		szReading = "0x" + szReading;
	}
	else          
	{
		sprintf(szval,"  %d", val);
		szReading.Format(_T("%s"), szval) ; 
	}

	bus_busy=0;
	//buttons(ON); //not used
	return szReading;
}

//===========================================================================
int UM245R_Interface::read_param(int index, unsigned int *val)
{
	unsigned char tx[5], rx[2];
	int				mode;
	long int		wait_count=0;
	char			msg[80];

	DWORD ret_bytes, bytes_in_buf=0;
	FT_STATUS status;

	if(!board_present)
		return -1;

	bus_busy=1;
	//buttons(OFF); //not used

	// Setup Header //full address mode read 
	mode  = 0;
	tx[0] = (mode << 5) + ((2*index & 0x1F0000) >> 16);
	tx[1] = (2*index & 0x00FF00) >> 8;
	tx[2] = (2*index & 0x0000FF);
	tx[3] = 0x00;
	tx[4] = 0x02; // One 16 bit parameter

	Write(tx, 5, &ret_bytes);

	//--------------------------------------------------------
	// Get requested data from the receiver
	while(bytes_in_buf < 2)
	{ 
		GetQueueStatus(&bytes_in_buf);	

		if(wait_count++ > 0xFFFFF)
		{
			sprintf(msg,"* TIMED OUT Bytes = %d *",bytes_in_buf);
			AfxMessageBox(msg);
			return -1;
		}
		
	}

	if(bytes_in_buf >= 2) 
	{
		status = Read(rx, 2, &ret_bytes);
		if((status == FT_OK) || ((status == FT_IO_ERROR) && (ret_bytes > 0)) /* Read timeout */)
		{
			*val = (rx[1]<<8) + rx[0];			 
		}
	}
	//sprintf(msg,"value = %d", val);
	//AfxMessageBox(msg);

	bus_busy=0;
	//buttons(ON); //not used
	return 1;
}

//===========================================================================
int UM245R_Interface::write_param_str(long index, CString szSetting)
{
	char* szparam;
	unsigned int val=0;
	int status;

	szparam = szSetting.GetBuffer(0);
	val = strtoul (szparam,NULL,0);  // intellegent string to unsigned long

	status = write_param(index, &val);
	return status;
}

//===========================================================================
int UM245R_Interface::write_param(int index, unsigned int *val)
{
	unsigned char tx[7];
	int mode;
	DWORD ret_bytes;

	if(!board_present) return -1;

	bus_busy=1;
	//buttons(OFF); //not used
	
	// Setup Header //full address mode read 
	mode  = 1;
	tx[0] = (mode << 5) + ((2*index & 0x1F0000) >> 16);
	tx[1] = (2*index & 0x00FF00) >> 8;
	tx[2] = (2*index & 0x0000FF);
	tx[3] = 0x00;
	tx[4] = 0x02; // One 16 bit parameter

	tx[5] = *val & 0x00FF;
	tx[6] = (*val & 0xFF00) >> 8;

	Write(tx, 5+2, &ret_bytes);


	bus_busy=0;
	//buttons(ON); //not used
	
	return 1;
}

int UM245R_Interface::read_chan(int index, unsigned int *val)
{
	unsigned char tx[5], rx[2];
	int				mode;
	long int		wait_count=0;
	char			msg[80];

	DWORD ret_bytes, bytes_in_buf=0;
	FT_STATUS status;

	if(!board_present)
		return -1;

	bus_busy=1;
	//buttons(OFF); //not used

	if(index > 31){index = 31; AfxMessageBox("ERROR: Channel index > 31");}

	// Setup Header //single channel mode read 
	mode  = 2;
	tx[0] = (mode << 5) + (index);

	Write(tx, 1, &ret_bytes);

	//--------------------------------------------------------
	// Get requested data from the receiver
	while(bytes_in_buf < 2)
	{ 
		GetQueueStatus(&bytes_in_buf);	

		if(wait_count++ > 0xFFFFF)
		{
			sprintf(msg,"* TIMED OUT Bytes = %d *",bytes_in_buf);
			AfxMessageBox(msg);
			return -1;
		}
		
	}

	if(bytes_in_buf >= 2) 
	{
		status = Read(rx, 2, &ret_bytes);
		if((status == FT_OK) || ((status == FT_IO_ERROR) && (ret_bytes > 0)) /* Read timeout */)
		{
			*val = (rx[1]<<8) + rx[0];			 
		}
	}
	//sprintf(msg,"value = %d", val);
	//AfxMessageBox(msg);

	bus_busy=0;
	//buttons(ON); //not used
	return 1;
}

//=======================================================================
int UM245R_Interface::write_param_bit(int index, int bit, int setting)
{
	unsigned int	val;
	int				status;
	unsigned int   word = 1;
	
	status = read_param(index, &val);
	if (status < 0) {AfxMessageBox("Parameter Read Failed"); return -1;}

	// set up our word used to change the bits
	word = word << bit;

	if (setting == 1)	val = val | word;
	else				val = val & ~word;

	write_param(index, &val);

	return 1;
}
