//---------------------------------------------------------------------------
//
// Copyright (C) 2001 Don Powrie, DLP Design, All Rights Reserved.
// 
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this source code to use it without restriction, including without 
// limitation the rights to use, copy, modify, merge, publish, distribute, 
// sublicense, and/or sell copies of the Software, and to permit persons to 
// whom the source code is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included 
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
// IN NO EVENT SHALL DLP DESIGN BE LIABLE FOR ANY CLAIM, DAMAGES 
// OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
// OTHER DEALINGS IN THE SOFTWARE.
// 
//---------------------------------------------------------------------------

// USBtestDlg.h : header file
//

#if !defined(AFX_USBTESTDLG_H__07909306_D75E_11D4_A644_93781B97CC41__INCLUDED_)
#define AFX_USBTESTDLG_H__07909306_D75E_11D4_A644_93781B97CC41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "UM245R_Interface.h"
#include "Parameter.h"
#include "Param_File_Dialog.h"  
#include "SaveParamDlg.h" 
#include "PD2_Checkout.h"
#include "SaveRequest.h"

UINT ThreadProc1(LPVOID param);
const int ON = 100;
const int OFF = 101;


// CUSBtestDlg dialog
class CUSBtestDlg : public CDialog
{
// Construction
public:
	void ParamUpdate();
	CUSBtestDlg(CWnd* pParent = NULL);	// standard constructor
	int  Number_of_Params_Used;
	void Compute_PhysUnits_Param(int i);
	int  m_file_loaded;
	int  mparams_ready;

	void SaveModuleParams();
	void Initialize_Parameter_Objects();
	void GetParamFromModule();
	
	UM245R_Interface   *pUM245R;
	CString				szParamFilename;
	CParameter			Prm[12];


	void CUSBtestDlg::buttons(int onoff);
	void CUSBtestDlg::Initialize_USB_Interface();
//	FT_STATUS Write(LPVOID, DWORD, LPDWORD);




// Dialog Data
	//{{AFX_DATA(CUSBtestDlg)
	enum { IDD = IDD_USBTEST_DIALOG };
	CListBox	m_Received;
	CString	m_PortStatus;
	long	m_NumRecd;
	CString	m_128status;
	CString	m_strFirst_Addr;
	UINT	m_nbytes;
	CString	m_szParamSetting0;
	CString	m_szParamReading0;
	long	m_nParamBaseAddr;
	CString	m_szParamSetting1;
	CString	m_szParamSetting10;
	CString	m_szParamSetting11;
	CString	m_szParamSetting12;
	CString	m_szParamSetting13;
	CString	m_szParamSetting14;
	CString	m_szParamSetting15;
	CString	m_szParamSetting2;
	CString	m_szParamSetting3;
	CString	m_szParamSetting4;
	CString	m_szParamSetting5;
	CString	m_szParamSetting6;
	CString	m_szParamSetting7;
	CString	m_szParamSetting8;
	CString	m_szParamSetting9;
	CString	m_szParamReading1;
	CString	m_szParamReading10;
	CString	m_szParamReading11;
	CString	m_szParamReading12;
	CString	m_szParamReading13;
	CString	m_szParamReading14;
	CString	m_szParamReading15;
	CString	m_szParamReading2;
	CString	m_szParamReading3;
	CString	m_szParamReading4;
	CString	m_szParamReading5;
	CString	m_szParamReading6;
	CString	m_szParamReading7;
	CString	m_szParamReading8;
	CString	m_szParamReading9;
	CString	m_szParamFilename;
	CString	m_szdescrp_0;
	CString	m_szdescrp_1;
	CString	m_szdescrp_10;
	CString	m_szdescrp_11;
	CString	m_szdescrp_12;
	CString	m_szdescrp_13;
	CString	m_szdescrp_14;
	CString	m_szdescrp_15;
	CString	m_szdescrp_2;
	CString	m_szdescrp_3;
	CString	m_szdescrp_6;
	CString	m_szdescrp_4;
	CString	m_szdescrp_5;
	CString	m_szdescrp_7;
	CString	m_szdescrp_8;
	CString	m_szdescrp_9;
	CString	m_szphysunits_0;
	CString	m_szphysunits_1;
	CString	m_szphysunits_10;
	CString	m_szphysunits_11;
	CString	m_szphysunits_12;
	CString	m_szphysunits_13;
	CString	m_szphysunits_14;
	CString	m_szphysunits_15;
	CString	m_szphysunits_2;
	CString	m_szphysunits_3;
	CString	m_szphysunits_4;
	CString	m_szphysunits_5;
	CString	m_szphysunits_6;
	CString	m_szphysunits_7;
	CString	m_szphysunits_8;
	CString	m_szphysunits_9;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUSBtestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	int  GetParamsFromFile(CString filename);
	void DisplayPhysUnits();
	void SaveParamsToFile(CString filename);
	int  LoadParamsFromFile2(CString filename);

	CString UpdateParameter(long int index, CString setting, CString reading);

	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CUSBtestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonClear();
	afx_msg void OnButtonNewRead();
	afx_msg void OnChangeFirstAddr();
	afx_msg void OnChangeNBytes();
	afx_msg void OnButtonNewWrite();
	afx_msg void OnParamUpdate();
	afx_msg void OnKillfocusParamFilename();
	afx_msg void OnTestButton1();
	afx_msg void OnSaveParam();
	afx_msg void OnLoadParam();
	afx_msg void OnOpenUsb();
	afx_msg void OnOpenPd2Checkout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_USBTESTDLG_H__07909306_D75E_11D4_A644_93781B97CC41__INCLUDED_)




